use anyhow::{Context, Result};

use crate::task_msg::RawEthFrameMessage;

pub async fn tap_junction_main(
    tx_for_mod: tokio::sync::mpsc::Sender<RawEthFrameMessage>,
    rx_for_eth_inb: tokio::sync::mpsc::UnboundedReceiver<RawEthFrameMessage>,
) -> Result<()> {
    const MTU: i32 = 1500;
    let tap_dev = tokio_tun::Tun::builder()
        //.tap()
        .name("sang")
        .mtu(MTU)
        .address("10.185.0.1".parse()?)
        .netmask("255.255.255.0".parse()?)
        .up()
        .try_build()
        .context("failed to construct tap device! could this be a permissions issue? try `setcap CAP_NET_ADMIN=ep /path/to/binary`")?;

    let mut buf = [0u8; MTU as usize];
    loop {
        let frame_length = tap_dev.recv(&mut buf).await?;
        println!("{:?}", &buf[..frame_length]);
        tx_for_mod.send((&buf[..frame_length]).to_vec()).await?;
    }
}
